﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7
@EndOfDesignText@
Sub Class_Globals
	Public connected As Boolean
	Private client As Socket
	Public server As ServerSocket
	Private astream As AsyncStreams
	Public ThePort As Int 'default = 51070
	Public TheCaller As Object
	Public TheHost As String 
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (Data As DataToPass)
	CallNetwork(Data)
End Sub

public Sub CallNetwork (theData2 As DataToPass)
	Dim TheData As DataToPass
	TheData.Initialize
	TheCaller = theData2.caller
	ThePort = theData2.port
	TheHost = theData2.host
End Sub
Public Sub ConnectToServer
	CloseExistingConnection
	Dim client As Socket
	client.Initialize("client")
	client.Connect(TheHost, ThePort, 10000)
	Wait For Client_Connected (Successful As Boolean)
	If Successful Then
		astream.InitializePrefix(client.InputStream, False, client.OutputStream, "astream")
		UpdateState (True)
	Else
		Log("Failed to connect. Check that B4XIDEViewer is running. " & LastException)
	End If
End Sub

Public Sub Disconnect
	CloseExistingConnection
End Sub

Sub CloseExistingConnection
	If astream.IsInitialized Then astream.Close
	If client.IsInitialized Then client.Close
	UpdateState (False)
End Sub

Sub UpdateState (NewState As Boolean)
	connected = NewState
	CallSub(TheCaller, "ShowSetState")
End Sub

Sub AStream_Error
	UpdateState(False)
End Sub

Sub AStream_Terminated
	UpdateState(False)
End Sub

Sub AStream_NewData (Buffer() As Byte)
	CallSub2(TheCaller, "NewData", Buffer)
End Sub

Public Sub SendData (data() As Byte)
	If connected Then astream.Write(data)
End Sub